﻿using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Linq;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Xml.Linq;

using DotNetNuke;
using DotNetNuke.Security;
using LinqThings4Sale;
using DotNetNuke.Common;

namespace DotNetNuke.Modules.LinqThings4Sale
{
    public partial class EditItem : DotNetNuke.Entities.Modules.PortalModuleBase
    {
        #region QueryString
        public int RecordID
        {
            get
            {
                if (Request.QueryString["RecordID"] == null)
                {
                    return 0;
                }
                else
                {
                    return Convert.ToInt16(Request.QueryString["RecordID"]);
                }
            }
        }
        #endregion

        protected void Page_Load(object sender, EventArgs e)
        {
            if (UserId == -1)
            {
                lnkBack.Text = "You must be logged in to add or edit a listing";
                pnlEditItem.Visible = false;
            }
            else
            {
                if (RecordID == -1)
                {
                    FVItem.ChangeMode(FormViewMode.Insert);
                }
                else
                {
                    if (PortalSecurity.IsInRole("Administrators") || AllowedToEdit())
                    {
                        FVItem.ChangeMode(FormViewMode.Edit);
                    }
                    else
                    {
                        lnkBack.Text = "You are not allowed to edit this listing";
                        pnlEditItem.Visible = false;
                    }
                }
            }
        }

        private bool AllowedToEdit()
        {
            LinqThings4SaleDataContext LinqThings4SaleDataContext = new LinqThings4SaleDataContext();

            var result = from item in LinqThings4SaleDataContext.ThingsForSales
                         where item.ID == RecordID
                         & item.UserID == UserId
                         select item;

            return (result.Count() > 0);
        }

        #region LinqDataSource Events
        protected void LDSEditItem_Selecting(object sender, LinqDataSourceSelectEventArgs e)
        {
            e.WhereParameters["ModuleId"] = ModuleId;
            e.WhereParameters["ID"] = RecordID;
        }

        protected void LDSEditItem_Inserting(object sender, LinqDataSourceInsertEventArgs e)
        {
            ThingsForSale ThingsForSale = (ThingsForSale)e.NewObject;

            ThingsForSale.UserID = Entities.Users.UserController.GetCurrentUserInfo().UserID;
            ThingsForSale.ModuleId = ModuleId;
        }
        #endregion

        #region LinkButton Events

        protected void lnkBack_Click(object sender, EventArgs e)
        {
            Response.Redirect(Globals.NavigateURL(), true);
        }

        protected void LDSEditItem_Inserted(object sender, LinqDataSourceStatusEventArgs e)
        {
            Response.Redirect(Globals.NavigateURL(), true);
        }

        protected void LDSEditItem_Updated(object sender, LinqDataSourceStatusEventArgs e)
        {
            Response.Redirect(Globals.NavigateURL(), true);
        }

        protected void InsertCancelButton_Click(object sender, EventArgs e)
        {
            Response.Redirect(Globals.NavigateURL(), true);
        }

        protected void LDSEditItem_Deleted(object sender, LinqDataSourceStatusEventArgs e)
        {
            Response.Redirect(Globals.NavigateURL(), true);
        }

        protected void UpdateCancelButton_Click(object sender, EventArgs e)
        {
            Response.Redirect(Globals.NavigateURL(), true);
        }
        #endregion
    }
}